/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2008-2017 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_support.S 2268 2011-11-22 16:22:45Z ertl-honda $
 */

/*
 *  ץå¸⥸塼 ֥ARM-Mѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"
#include "arm_m.h"
#include "offset.h"
#include "target_asm.inc"

/*
 *  ǥѥå
 */
	ATEXT
	AALIGN(2)
	ATHUMB(dispatch)
	AGLOBAL(dispatch)
ALABEL(dispatch)
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {lr}
	bl      ovrtimer_stop
	pop     {lr}
#endif /* TOPPERS_SUPPORT_OVRHDR */
	/*
	 *
	 *  Υ롼ϡƥȡCPUå֡ǥѥåľ
	 *  ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ롥
	 */
	stmfd sp!,{r4-r11,lr}         /* 쥸¸ */
#ifdef TOPPERS_FPU_CONTEXT
	/* 
	 * ǥѥåΥFPUѤFPU쥸¸
	 */ 
	mrs   r0, control             /* CONTROL.FPCA == 0(FPṲ)ʤХå */ 
	tst   r0, #CONTROL_FPCA
	beq   dispatch_1
	vpush {s16-s31}               /* FPU쥸¸ -(16*4) */ 
ALABEL(dispatch_1)
	push  {r0,r1}                 /* ȽѤCONTROL(r0)¸, r1ϥåĴΤΥߡ -8 */ 
#endif /* TOPPERS_FPU_CONTEXT */
	ldr   r0, =p_runtsk           /* p_runtskɤ߹ */
	ldr   r1, [r0]
	str   sp, [r1,#TCB_ssp]        /* Υƥॹå¸ */
	ldr   lr, =dispatch_r         /* ¹ԺƳϤ¸ */
	str   lr, [r1,#TCB_pc]        
	b     dispatcher

	ATHUMB(dispatch_r)
	AGLOBAL(dispatch_r)
ALABEL(dispatch_r)
#ifdef TOPPERS_FPU_CONTEXT 
	/* 
	 * ǥѥåΥFPUѤƤFPU쥸
	 * å¸CONTROL.FPCAå 
	 */ 
	pop   {r3,r4}           /* CONTROL(r3), r4ϥåĴΤΥߡ +8 */ 
	tst   r3, #CONTROL_FPCA /* CONTROL.FPCA == 0(FPṲ)ʤХå */ 
	beq   dispatch_r_0
	vpop {s16-s31}          /* FPU쥸  +(16*4) */  
ALABEL(dispatch_r_0)
#endif /* TOPPERS_FPU_CONTEXT */
	ldmfd sp!,{r4 - r11,lr}       /* 쥸 */
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r1, lr}
	bl      ovrtimer_start
	pop     {r1, lr}
#endif /* TOPPERS_SUPPORT_OVRHDR */
	/*
	 * 㳰롼εư
	 * dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
	 */
	ldrb  r0,[r1,#TCB_enatex]
	tst   r0,#TCB_enatex_mask
	beq   dispatch_r_1            /* enatex  false ʤ꥿ */
	ldr   r0,[r1,#TCB_texptn]     /* texptn  0 ʤ꥿     */
	tst   r0,r0
	beq   dispatch_r_1            
	ldr   r2, =ipmflg             /* ipmflg false ʤ꥿  */
	ldr   r0, [r2]
	tst   r0,r0
	beq   dispatch_r_1
	ldr     r2, =rundom
	ldr     r0, [r2]
	tst     r0, r0                /* rundom == 0(TACP_KERNEL)  */
	bne     dispatch_r_1
	ldrb    r0, [r1, #TCB_svclevel]  /* r0 = svclevel */
	tst     r0, r0              /* svclevel == 0 ? */
	bne     dispatch_r_1       /* ĥӥƽФʤdispatch_r_1 */
	ldr   r0, =call_texrtn_stask  /* 㳰롼θƤӽФ */
	bx    r0
ALABEL(dispatch_r_1)              /* ؤcall_textn */
	bx    lr


/*
 *  CPU㳰ȥ
 *
 *  ߥȥȽƤƱμबۤʤ뤿ᡤ
 *  ʬƤ롥
 */
	AALIGN(2)
	ATEXT
	ATHUMB(core_exc_entry)
	AGLOBAL(core_exc_entry)
ALABEL(core_exc_entry)
	/*
	 *  㳰/ߤȯȡȯ˥ƥ֤ʥå˥
	 *  å쥸¸롥
	 *  Ƥ˲äơCPU㳰ϥɥؤξȤơbasepri ͤȡ
	 *  EXC_RETURNξä¸롥basepriͤϡCPU㳰
	 *  ꥿˳ͥ٥ޥͤ򸵤᤹ˤѤ롥
	 *
	 *   -----------
	 *  |  basepri  |  
	 *   -----------
	 *  | EXC_RETURN|  
	 *   -----------
	 *  |    R0     |  
	 *   -----------
	 *  |    R1     |
	 *   -----------
	 *  |    R2     |
	 *   -----------
	 *  |    R3     |
	 *   -----------
	 *  |    R12    |
	 *   -----------
	 *  |    LR     |
	 *   -----------
	 *  |    PC     |
	 *   -----------
	 *  |   xPSR    |
	 *   -----------
	 *
	 */

	/*
	 *  ͥ㳰å
	 *  ͥΥƥ륻μ¹桤ߥå֡
	 *  CPUå֡ͥγߥϥɥ¹Τ줫
	 *  ȯCPU㳰򡤥ͥCPU㳰ȸƤ
	 *  ߥå֤FAULTMASK'1'ξ
	 *  CPUå֤basepriIIPM_LOCKȽǤ롥
	 */
	mrs   r2, FAULTMASK           /* ߥå֤ʤ饫ͥ㳰 */
	cbnz  r2, core_nonkernel_exc_entry

	mrs   r0, basepri             /* baepriͤ */
	cmp   r0, #IIPM_LOCK          /* CPUå֤ʤ饫ͥ㳰 */
	beq   core_nonkernel_exc_entry

	/*
	 * åѹɬפ뤫å
	 * EXC_RETURNʳ߻LRꤵ͡ˤåơ㳰ȯ
	 * ƥ֤ʥåꤹ뤳Ȥ¿ųߤȽꤹ롥
	 */
	tst   lr, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	beq   core_exc_entry_1       /* ¿ųߤʤcore_exc_entry_1 */
	mrs   r3, psp                /* ܤγߤξPSP */
	stmfd r3!, {r0, lr}          /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νPSPѤ -8 */
	msr   psp, r3                
	push  {r0,lr}                /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νMSPѤ -8 */
	mov   r0, r3                 /* CPU㳰ϥɥؤΰȤʤ */
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r0}
	bl      ovrtimer_stop
	pop     {r0}
#endif /* TOPPERS_SUPPORT_OVRHDR */
	b     core_exc_entry_2
ALABEL(core_exc_entry_1)         /* ¿ųߤξ */
	push  {r0,lr}                /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νPSPѤ -8 */
	mov   r0, sp                 /* CPU㳰ϥɥؤΰȤʤ */

	/*
	 *  ̽
	 */
ALABEL(core_exc_entry_2)
	mrs   r3, ipsr               /* ϥɥ饢ɥ쥹 */
ALABEL(core_exc_entry_3)
	ldr   r1, =_kernel_exc_tbl
	ldr   r2, [r1, r3, lsl #2]

#ifdef LOG_EXC_ENTER
	push  {r0,r1,r2,r3}          /* r1ϥåĴΤΥߡ -16 */
	mov   r0, r3                 /* 㳰ֹѥ᡼  */
	bl    log_exc_enter          /* log_exc_enterƤӽФ */
	pop   {r0,r2,r3}
	pop   {r0,r1,r2,r3}          /* r1ϥåĴΤΥߡ +16 */
	push  {r3,r4}                /* 㳰ֹ(r3)򥹥å,r4ϥåĴΤΥߡ -8 */
#endif /* LOG_EXC_ENTER */

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	blx   r2

#ifdef LOG_EXC_ENTER
	pop   {r0,r1}                /* 㳰ֹˡr1ϥåĴΤΥߡ +8 */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_ENTER */

	b     ret_exc

/*
 *  ͥCPU㳰ν
 */
ALABEL(core_nonkernel_exc_entry)
	tst   lr, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	beq   core_nonkernel_exc_entry_1  /* ¿ųߤʤ */
	mrs   r3, psp                /* ܤγߤξPSP */
	stmfd r3!, {r0, lr}          /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νPSPѤ -8 */
	msr   psp, r3                
	push  {r0,lr}                /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νMSPѤ -8 */
	mov   r0, r3                 /* CPU㳰ϥɥؤΰȤʤ */
	b     core_nonkernel_exc_entry_2
ALABEL(core_nonkernel_exc_entry_1) /* ¿ųߤξ */
	push  {r0,lr}                /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νPSPѤ -8 */
	mov   r0, sp                 /* CPU㳰ϥɥؤΰȤʤ */

ALABEL(core_nonkernel_exc_entry_2)
	mrs   r3, ipsr               /* CPU㳰ϥɥΥɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	ldr   r2, [r1, r3, lsl #2]

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	blx   r2

	/*
	 *  ߥå֤Ȥ롥
	 */
	cpsid f

	/*
	 *  ΥƥȤȽ
	 * 
	 *  ߥϥɥ¹ԤLR˥åȤEXC_RETURNåơ
	 *  MSPȤƤС褬󥿥ƥȤȽꤹ롥
	 */
	pop   {r1,r3}                  /* γͥ٥ޥ(basepri)r1ءEXC_RETURNr3 -8 */
	tst   r3, #EXC_RETURN_PSP      /* 褬PSPʤ              */
	bne   core_nonkernel_ret_exc_1
	b     core_nonkernel_ret_exc_2 /* ͤMSP */

ALABEL(core_nonkernel_ret_exc_1)
	/*
	 *  PSP夫顤EXC_RETURN(r0)ȸγͥ٥ޥ(basepri)ʬ
	 */
	mrs   r2, psp
	add   r2, r2, #(0x04*2)
	msr   psp, r2

ALABEL(core_nonkernel_ret_exc_2)
	msr   basepri, r1             /* ͥ٥ޥ˾֤ */
	bx    r3                      /* ꥿ */

/*
 *  ߥȥ
 */
	ATHUMB(core_int_entry)
	AGLOBAL(core_int_entry)
ALABEL(core_int_entry)
	/*
	 *  ȯγͥ٥ޥ򥹥å¸뤿
	 */
	mrs   r0, basepri             /* baepriͤ */

	/*
	 * ¿ųߤå
	 * EXC_RETURNʳ߻LRꤵ͡ˤåơ㳰ȯ
	 * ƥ֤ʥåꤹ뤳Ȥ¿ųߤȽꤹ롥
	 */
	tst   lr, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	beq   core_int_entry_1       /* ¿ųߤʤcore_int_entry_1 */
	mrs   r3, psp                /* ܤγߤξPSP */
	stmfd r3!, {r0, lr}          /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νPSPѤ -8 */
	msr   psp, r3
	push  {r0,lr}                /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νMSPѤ -8 */
	mov   r0, r3                 /* ̤γߤȯξȤ */
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r0}
	bl      ovrtimer_stop
	pop     {r0}
#endif /* TOPPERS_SUPPORT_OVRHDR */
	b     core_int_entry_2
ALABEL(core_int_entry_1)         /* ¿ųߤξ */
	push  {r0,lr}                /* ȯγͥ٥ޥ(r0)EXC_RETURN(lr)νPSPѤ -8 */
	mov   r0, sp                 /* ̤γߤȯξȤ */

	/*
	 *  ̽
	 */
ALABEL(core_int_entry_2)
	mrs   r3, ipsr               /* ϥɥ饢ɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	ldr   r2, [r1, r3, lsl #2]

	/*
	 *  basepri
	 *  NVICͥ٥ޥưŪꤵ뤿ͥ٥ޥǤɬפ
	 *  x_get_ipm()basepri򻲾Ȥ뤿ᡤbasepri⹹롥
	 */
	ldr   r1, =_kernel_int_iipm_tbl
	ldr   lr, [r1, r3, lsl #2]
	msr   basepri, lr

#ifdef LOG_INH_ENTER
	push  {r0,r2,r3}
	mov   r0, r3                 /* 㳰ֹѥ᡼  */
	bl    log_inh_enter          /* log_exc_enterƤӽФ */
	pop   {r0,r2,r3}
	push  {r3}                   /* 㳰ֹ򥹥å    */
#endif /* LOG_EXC_ENTER */

	/*
	 *  ߥϥɥθƤӽФ
	 */
	blx   r2

#ifdef LOG_INH_LEAVE
	pop   {r0}                   /* 㳰ֹ        */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */



/*
 *  /㳰и
 *
 *  ret_exc/ret_intϡCPU㳰/ߥϥɥ餫äľ˼¹Ԥ
 *  롼Ǥ롥
 */
ALABEL(ret_exc)
ALABEL(ret_int)
	/*
	 *  ߥå֤Ȥ롥λǤϡCPUå֤ˤϤʤʤ
	 * baseprilock_flagsaved_iipmϹʤˡ
	 *
	 *  ߥå֤ȤΤϡΥƥȤΥåȡ
	 *  褬󥿥ƥȤǤäΥ꥿򥢥ȥߥå
	 *  ˹ԤǤ롥bsepriCPUåͤˤ뤳ȤǤ⥢ȥߥ
	 *  ʥåϲǽǤ뤬ߤ꥿󤷤Ƥ⡤
	 *  basepri ƤϸʤᡤѤ뤳ȤǤʤ 
	 *  FAULTMASKϡߤΥ꥿ˤäơ'0'˥
	 *  롥
	 */
	cpsid f

	/*
	 *  ΥƥȤȽ
	 * 
	 *  ߥϥɥ¹ԤLR˥åȤEXC_RETURNåơ
	 *  MSPȤƤС褬󥿥ƥȤȽꤹ롥
	 */
	pop   {r1,r3}                  /* γͥ٥ޥ(basepri)r1ءEXC_RETURNr3 +8 */
	tst   r3, #EXC_RETURN_PSP      /* 褬PSPʤ ret_int_1  */
	bne   ret_int_1
	b     ret_int_2

	/*
	 *  ܤγߤνи
	 */
ALABEL(ret_int_1)
	/*
	 *  reqflgå
	 * 
	 *  ͥγߤ϶ػߤ֤Ǽ¹Ԥɬפ뤿ᡤ
	 *  FAULTMASK'1'ˤ֤Ǽ¹Ԥ롥
	 *  reqflgå˳ߤػߤΤϡreqflgå
	 *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
	 *  줿ˡ˥ǥѥåʤȤ꤬뤿
	 *  Ǥ롥
	 */
	ldr   r0, =reqflg             /* reqflgfalseʤ餽Τޤ */
	ldr   r2, [r0]
	cbnz  r2, ret_int_3           /* trueʤret_int_3           */

	/*
	 *  PSP夫顤EXC_RETURN(r0)ȸγͥ٥ޥ(basepri)ʬ
	 */
	mrs   r2, psp
	add   r2, r2, #(0x04*2)
	msr   psp, r2


#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r1,r3}
	bl      ovrtimer_start
	pop     {r1,r3}
#endif /* TOPPERS_SUPPORT_OVRHDR */
ALABEL(ret_int_2)
	/*
	 *  ˤϳߥå֡FAULTMASKåȡˤ줿֤롥
	 *  Thread⡼ɤΥ꥿ˤ꼫ưŪ˳ߥå֤ˤʤ롥
	 *  ͥ٥ޥϳ˾֤᤹
	 */ 
	msr   basepri, r1             /* ͥ٥ޥ˾֤ */
	bx    r3                      /* ꥿ */

ALABEL(ret_int_3)
	/*
	 *  Ǥϡ褬ǤꡤPSP˥å쥸ȳ
	 *  ͥ٥ޥ(basepri)¸줿֤ˤʤäƤ롥ޤ
	 *  ץåϡHandler⡼ɡߥå֤ȤʤäƤ롥
	 *  ޤr0ˤϡreqflgΥɥ쥹r3ˤϳ߼ջlrͤ
	 *  Ƥ롥
	 */
	/*
	 *  㳰ϥɥǥѥå򤹤ݤThread⡼ɤܤ
	 *  ߡΥåե졼ơbx̿Handler⡼ɤ
	 *  󤹤롥ޤٱǥѥå⡤Ƥӳ
	 *  ݤˤϡsvc̿ǡsvc_handlerƤӽФ
	 *  åե졼ϡConfigureation and Control Register(CCR)
	 *  STKALIGN'1'ξϡ8byte˥饤󤵤롥
	 *   : DDI0403B_arm_architecture_v7m_reference_manual(P.220)
	 *  ΤᡤλΥåϳߤ㳰ȯ˺줿
	 *  åե졼फ顤8byteΥˤƤȡsvc_handler
	 *  ǥåե졼Υ饤Ȥ̵ͭγǧάǤ롥
	 *  ƥ൯ưϡưŪCCRSTKALIGNѹΤ
	 *  ػߤȤ롥
	 *  λɸΥåե졼ϡߡ㳰ȯƱǤ
	 *  뤿ᡤå(PSP)8byteˤʤäƤ롥
	 */
	mov   r1, #0                   /* reqflgfalse */
	str   r1, [r0]

	/*
	 *  CPUå֤˰ܹԤ롥
	 *
	 *  ͥδγߤػߤ褦basepriꤷ
	 *  lock_flag  saved_iipm 򹹿롥saved_iipmϡγ
	 *  ͥ٥ޥʤɽˤꤹ롥
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 *  ʤνθ塤Thread⡼ɤؤΰܹԽԤʤᡤ
	 *  å(FAULTMASK"1")ݻ롥
	 */
	ldr   r1, =IIPM_LOCK          /* CPUå */ 
	msr   basepri, r1          
	mov   r1, #0x01               /* lock_flag  true */
	ldr   r0, =lock_flag          
	str   r1, [r0]

	/*
	 *  ͥ٥ޥ֡TIPM_ENAALLˤꤹ
	 *  ǤCPUå֤ʤΤǡsaved_iipmIIPM_ENAALLȤ롥
	 */
	ldr   r1, =IIPM_ENAALL
	ldr   r0, =saved_iipm
	str   r1, [r0]

	/*
	 *  μ¹ԥ⡼ɤ¸뤿ᡤCONTROLpsp
	 */
	mrs     r0, control /* r0 = CONTROL */
	mrs     r2, psp
	stmfd   r2!, {r0}   /* CONTROLpspѤ */
	mov     r0, #0x00   
	msr     control, r0 /* Thread⡼ɰܹԸø⡼ɤ */
	isb                 /* control ɬ */

	/*
	 *  Thread⡼ɤذܹԤ롥
	 *
	 *  dispatchercall_texrnƤӽФϡThread⡼ɤǤɬ
	 *  פ뤿ᡤPSPå˥ߡ㳰ե졼֤ơ
	 *  Ū˳ߥϥɥ餫꥿󤹤롥
	 *  ꥿ƱFAULTMASKưŪ˥ꥢ졤ͥ
	 *  ߤĤ롥
	 */
	ldr   r0, =ret_int_4          /* PC   */
	ldr   r1, =EPSR_T             /* xPSR(TӥåȤ'1'Ǥɬפ) */
	stmfd r2!, {r0-r1}            /* ߡե졼򥹥åѤ   */
	sub   r2, #(EXC_FRAME_SIZE - (4*2)) /* r0-r3,r12,lrƤꤹɬפʤ */
	msr   psp,r2           
	/* Basicե졼ࡤTHREAD⡼ɡPSPΤ EXC_RETURN */
	mov   r0, #(EXC_RETURN_TREAD_PSP|EXC_RETURN_OTHER|EXC_RETURN_FP_NONUSED)
	bx    r0                      /* Thread⡼ɡøˤذܹ */
    
ALABEL(ret_int_4)
	/*
	 *  嵭νˤꡤThread⡼ɡøˤǼ¹Ԥ롥
	 *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
	 *  ǥѥåԤʤΥåɬפʤΤϡ㳰
	 *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
	 *  reqflgtrueˤ뤿Ǥ롥
	 */
	ldr   r0, =p_runtsk       /* ǥѥåԤʤǤ⡤r1p_runtsk (TCB) */
	ldr   r1, [r0]            /* äƤɬפΤǡɤ߹ */
	pop   {r0}                /* pspCONTROL */
	ldr   r3, [sp,4]          /* EXC_RETURN */ 

	/*
	 *  褬桼⡼ɤ
	 */
	mov     r2, #0x01           /* r2 = CONTROL_USER */
	tst     r0, r2              /* 褬ø⡼ɤ */
	beq     ret_int_5           /* 褬ø⡼ɤʤpspڤؤʤ */
	nop

	/*
	 *  pspsspڤؤ
	 *  ǤϡΥϥ㳰α֤ǤʤΤǡpriv_mode
	 *  ڤؤʤ
	 */
	str     sp, [r1,#TCB_usp]   /* usp¸ */
	ldr     sp, [r1,#TCB_ssp]   /* ssp */

ALABEL(ret_int_5)
	push    {r0}                /* pspcontrol */
	ldr   r0, =dspflg         
	ldr   r2, [r0]
	cbz   r2, ret_int_r_1     /* dspflgfalseʤret_int_r_1 */
	ldr   r0, =p_schedtsk     
	ldr   r2, [r0]
	cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
	beq   ret_int_r_1         /*                  ret_int_r_1 */
#ifdef TOPPERS_FPU_CONTEXT
	/* 
	 * ǥѥåΥFPUѤFPU쥸¸
	 */ 
	tst   r3, #EXC_RETURN_FP
	bne   ret_int_6         /* EXC_RETURN[4] == 1(FPṲ)ʤХå */ 
	vpush {s16-s31}         /* FPU쥸¸ -(16*4) */ 
ALABEL(ret_int_6) 
	push {r3,r4}            /*  EXC_RETURN¸, r4ϥåĴΤΥߡ -8 */ 
#endif /* TOPPERS_FPU_CONTEXT */
	stmfd sp!, {r4-r11}       /* ĤΥ쥸¸ */
	str   sp, [r1,#TCB_ssp]   /* Υƥॹå¸ */
	ldr   lr, =ret_int_r      /* ¹ԺƳϤ¸   */
	str   lr, [r1,#TCB_pc]
	b     dispatcher          /* ǥѥå */

/*
 * ߤˤץꥨץȤ줿ؤΥ꥿
 *
 * Thread⡼ɤǡǥѥåߤνиƤӽФ롥
 * ߤˤץꥨץȤ줿إ꥿󤹤ˤϡä
 * Handler⡼ɤ˰ܹԤPC0xfffffffdƥ꥿󤹤ɬ
 * 롥ΤᡤSVCˤꡤSVCϥɥƤӽФHandler⡼
 * ɤذܹԤ롥
 */
	ATHUMB(ret_int_r)
	AGLOBAL(ret_int_r)
ALABEL(ret_int_r)
	pop {r4-r11}                  /* 쥸 +(8*4) */
#ifdef TOPPERS_FPU_CONTEXT 
	pop {r2, r3}     /*  EXC_RETURN r3ϥåĴΤΥߡ +8 */ 
	/* 
	 * ǥѥåΥFPUѤFPU쥸
	 */ 
	tst r2, #EXC_RETURN_FP
	bne ret_int_r_1      /* EXC_RETURN[4] == 1(FPṲ)ʤХå */ 
	vpop {s16-s31}       /* FPU쥸 +(8*4)*/ 
#endif /* TOPPERS_FPU_CONTEXT */
	/*
	 *  λǤɬPSP = sspǤ롥
	 */
ALABEL(ret_int_r_1)
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r1}
	bl      ovrtimer_start
	pop     {r1}
#endif /* TOPPERS_SUPPORT_OVRHDR */
	pop     {r3}                /* pspCONTROL */
	/*
	 *  enatextrueǡtexptn0ǤʤС㳰롼
	 *  ƤӽФ
	 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
	 */
	ldrb  r0, [r1,#TCB_enatex]
	tst   r0, #TCB_enatex_mask
	beq   ret_int_r_2           /* enatex  false ʤ ret_int_r_2 */
	ldr   r0, [r1,#TCB_texptn]  /* texptn  0 ʤ꥿     */
	cbz   r0, ret_int_r_2
	ldr   r2, =ipmflg           /* ipmflg false ʤ꥿  */
	ldr   r0, [r2]
	cbz   r0, ret_int_r_2
#ifdef TOPPERS_FPU_LAZYSTACKING
	/*  
	 *  Lazy Stacking  ߤνиʬ褿 
	 *  ߸ΥFPU  ߥϥɥFPṲѤξ,
	 *  (FPCCR.LSPACT == 1 ξ)
	 *  㳰ե졼FPUΥƥȤᤵƤʤ.
	 *  FPU̿¹Ԥ㳰ե졼FPUΥƥȤ᤹ɬפ
	 */
	ldr r2, =(FPCCR)
	ldr r0, [r2] 
	tst r0, #FPCCR_LSPACT
	beq ret_int_r_1_1     /* FPCCR.LSPACT == 0ʤХå */ 
	vmov r2, s15          /* ߡ̿㳰ե졼˽ᤷ */ 
ALABEL(ret_int_r_1_1)
#endif /* TOPPERS_FPU_LAZYSTACKING */
	/*
	 *  褬桼⡼ɤ
	 */
	tst     r3, #0x01           /* 褬ø⡼ɤ */
	bne     ret_int_r_user      /* 褬桼⡼ɤʤret_int_r_user */

	ldrb    r0, [r1,#TCB_svclevel]  /* svclevel  0 Ǥʤʤ꥿     */
	tst     r0, r0
	bne     ret_int_r_3
	nop

ALABEL(ret_int_r_ker)
	bl    call_texrtn_stask     /* 㳰롼θƤӽФ */
	b     ret_int_r_3
ALABEL(ret_int_r_user)
	/*
	 *  桼Υ㳰롼إפ
	 *  R0 = p_runtsk
	 *  CPUå
	 */
	mov   r0, #0
	ldr   r2, =lock_flag          /* CPUå֤ */
	str   r0, [r2]
	ldr   r0, =IIPM_ENAALL        /* ͥ٥ޥ֤ */
	msr   basepri, r0             
	mov   r0, r1
#ifdef TOPPERS_FPU_CONTEXT
	/*
	 *  SVCμ¹ԤFPUƥȤ򥹥åѤޤʤ褦
	 *  CONTROL.FPCA򥯥ꥢ
	 */
	mrs   r2, control       
	bic   r2, r2, #CONTROL_FPCA
	msr   control, r2
	isb                     /* control ɬ */
#endif /* TOPPERS_FPU_CONTEXT */
	svc   #NO_UTEX
	nop

	/*
	 *  CPUå
	 */
	ldr   r0, =IIPM_LOCK          /* CPUå */ 
	msr   basepri, r0          
	mov   r2, #0x01               /* lock_flag  true */
	ldr   r0, =lock_flag          
	str   r2, [r0]

ALABEL(ret_int_r_2)
	/*
	 *  ˤsvcΥ꥿뤿ᡤ
	 *  r1r3ˤϡp_runtskCONTROLäƤ
	 */
	tst     r3, #0x01
	beq     ret_int_r_3
	/*
	 *  pspuspڤؤ
	 *  ret_intǤϡpriv_modeڤؤʤΤǡǤڤؤʤ
	 */
	str     sp, [r1,#TCB_ssp]   /* ssp¸ */
	ldr     sp, [r1,#TCB_usp]   /* usp */
ALABEL(ret_int_r_3)
	/*
	 *  褬桼ʤСλǡPSP = uspǤ롥
	 */
	push    {r3}
#ifdef TOPPERS_FPU_CONTEXT
	/*
	 *  SVCμ¹ԤFPUƥȤ򥹥åѤޤʤ褦
	 *  CONTROL.FPCA򥯥ꥢ
	 */
	mrs   r3, control       
	bic   r3, r3, #CONTROL_FPCA
	msr   control, r3
	isb                     /* control ɬ */
#endif /* TOPPERS_FPU_CONTEXT */
	svc   0                     /* SVCθƤӽФ */

/*
 *  SVCϥɥ
 */
	ATHUMB(svc_handler)
	AGLOBAL(svc_handler)
ALABEL(svc_handler)
	/*
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
	 *  롥
	 */
	cpsid f                       /* ߥå֤ */
	/*
	 *  r0ˤ֤ or TCBäƤǽ뤿ᡤѤʤ
	 *  r1ˤTCBäƤǽ뤿ᡤѤʤ
	 */
	tst     lr, #0x04
	ite     eq
	mrseq   r2, msp
	mrsne   r2, psp
	ldr     r2, [r2, #24]
	ldrb    r2, [r2, #-2]
	ldr     r3, =svc_vector_tbl
	ldr     r3, [r3, r2, lsl #2]
	mov     pc, r3

/*
 *  ret_int_rνи
 */
	ATHUMB(ret_int_r_4)
	AGLOBAL(ret_int_r_4)
ALABEL(ret_int_r_4)
	mrs   r0, psp
	add   r0, #EXC_FRAME_SIZE     /* åΤƤ   */

	/*
	 *  ¹ԥ⡼ɤ򸵤᤹
	 */
	ldmfd   r0!, {r1}           /* pspcontrol */
	msr     control, r1
	isb                         /* control ɬ */
	ldmfd r0!,{r1,lr}           /* EXC_RETURNϡFPUѻ̤ѻǰۤʤ뤿᥹å +(2*4) */
	msr   psp, r0
	mov   r0, #0
	ldr   r1, =lock_flag        /* CPUå֤ */
	str   r0, [r1]
	ldr   r1, =IIPM_ENAALL      /* ͥ٥ޥ֤ */
	msr   basepri, r1             
	bx    lr                    /* ꥿     */

/*
 *  ǥѥåư
 */
	ATHUMB(start_dispatch)
	AGLOBAL(start_dispatch)
ALABEL(start_dispatch)
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  core_initializeǡlock_flagtrueˡsaved_iipmIIPM_ENAALL
	 *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
	 *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
	 *  ޤtask_initializedisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 */
	ldr   r0,=istkpt              /* MSP   */
	ldr   r1,[r0]                 /* start_dispatchƤӽФ˸ƤӽФѤ */
	msr   msp, r1                 /* ѤƤ뤿             */
	ldr   r1, =IIPM_LOCK          /* ͥγߤػ */
	msr   basepri, r1 
	cpsie f                       /* ͥγߤ */
	mov   r0, #CONTROL_PSP        /* PSPͭ  */
	msr   control, r0
	isb                           /* control ɬ */

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
	ATHUMB(exit_and_dispatch)
	AGLOBAL(exit_and_dispatch)
ALABEL(exit_and_dispatch)
	/* ǥѥåΡdispatcherˤ */ 


/*
 *  ǥѥå
 */
ALABEL(dispatcher)
	/*
	 *  Υ롼ϡƥȡCPUå֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥
	 *
	 *  ʤThread⡼ɡlock_flagtruedisdspfalsedspflg
	 *  truesaved_iipmIIPM_ENAALLȤʤäƤ롥¹ԺƳϤؤ⤳
	 *  ξ֤Τޤʬ롥
	 */
#ifdef TOPPERS_FPU_CONTEXT
	mrs   r1, control       /* ǥѥå¹ԻFPCAΧꥢ */
	bic   r1, r1, #CONTROL_FPCA
	msr   control, r1
	isb                     /* control ɬ */
#endif /* TOPPERS_FPU_CONTEXT */
#ifdef LOG_DSP_ENTER
	ldr   r1, =p_runtsk     /* p_runtskѥ᡼ */
	ldr   r0, [r1]        
	bl    log_dsp_enter
#endif /* LOG_DSP_ENTER */
ALABEL(dispatcher_0)
	ldr   r0, =p_schedtsk   /* p_schedtskp_runtsk */
	ldr   r1, [r0]
	ldr   r2, =p_runtsk   
	str   r1, [r2]        
	cbz   r1, dispatcher_1  /* p_runtskNULLʤdispatcher_1 */           
	ldr   sp, [r1,#TCB_ssp] /* Υƥॹå¸ */

	ldr     r2, [r1, #TCB_p_tinib]
	ldr     r3, [r2, #TINIB_p_dominib]
	ldr     r4, [r3, #DOMINIB_domptn]
	ldrb    r5, [r1, #TCB_svclevel]
	ldr     r0, =rundom
	cmp     r5, #0                      /* svclevel == 0 */
	bne     dispatcher_3
	nop
	/*
	 *  rundom = p_runtsk->p_tinib->p_dominib->domptn
	 */
	str     r4, [r0]
	b       dispatcher_4
	nop

ALABEL(dispatcher_3)
	mov     r5, #0
	str     r5, [r0]
ALABEL(dispatcher_4)
	cmp     r4, #0      /* domptn == 0ʥͥɥᥤˤ */
	beq     dispatcher_5

	/*
	 *  MPUݸΰ
	 */

	/*
	 *  桼åΰ
	 */
	ldr     r0, =#MPU_REGBASE   /* r0: ΰ١ɥ쥹쥸 */
	ldr     r5, [r2, #TINIB_start_ustk]  /* Ƭ */
	ldr     r4, [r2, #TINIB_atrsz_ustk]  /* ݸ°ȥ */
	ldr     r2, =#MPU_REGATR    /* r2: ΰ°ӥ쥸 */
	str     r5, [r0]
	str     r4, [r2]
	
	/*
	 *  ¹ԥɥᥤݸɥᥤ(MPU)ƱʤС
	 *  ɥᥤΥΰ衦ǡΰMPUꤷľɬפϤʤ
	 */
	ldr     r5, =p_ctxdom       /* r5 = &p_ctxdom */	
	ldr     r4, [r5]            /* r4 = p_ctxdom */
	cmp     r4, r3              /* p_ctxdom == p_dominb ? */
	beq     dispatcher_5        /* Ʊʤdispatcher_5 */
	nop
	str     r3, [r5]            /* p_ctxdom = p_dominib : ݸɥᥤؤ */
	ldr     r3, [r3, #DOMINIB_p_dominib_info]
  
	/*
	 *  ݸɥᥤѤRXΰ
	 */
	ldr     r5, [r3, #DOMINIB_start_rom]  /* Ƭ */
	ldr     r4, [r3, #DOMINIB_atrsz_rom]  /* ݸ°ȥ */
	str     r5, [r0]
	str     r4, [r2]

	/* 
	 * ݸɥᥤѤRWXΰ
	 */
	ldr     r5, [r3, #DOMINIB_start_ram]  /* Ƭ */
	ldr     r4, [r3, #DOMINIB_atrsz_ram]  /* ݸ°ȥ */
	str     r5, [r0]
	str     r4, [r2]

	/*
	 * ͭ꡼/ѥ饤ΰΰ
	 */
	ldr     r5, [r3, #DOMINIB_start_srpw]  /* Ƭ */
	ldr     r4, [r3, #DOMINIB_atrsz_srpw]  /* ݸ°ȥ */
	str     r5, [r0]
	str     r4, [r2]

	/*
	 * ATT_MEMϿ줿ΰ
	 */
	ldr     r5, [r3, #DOMINIB_start_mem]  /* Ƭ */
	ldr     r4, [r3, #DOMINIB_atrsz_mem]  /* ݸ°ȥ */
	str     r5, [r0]
	str     r4, [r2]

ALABEL(dispatcher_5)
#ifdef LOG_DSP_LEAVE
	mov   r0, r1            /* p_runtskѥ᡼ */
	mov   r4, r1            /* r1ϥå쥸ʤΤ¸ */
	bl    log_dsp_leave
	mov   r1, r4
#endif /* LOG_DSP_LEAVE */
	ldr   pc, [r1,#TCB_pc]  /* ¹ԺƳϤ   */    
ALABEL(dispatcher_1)
	/*
	 * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 * 򤹤
	 */
	mov   r0, #CONTROL_MSP  /* MSPͭ  */
	msr   control, r0       
	isb                     /* control ɬ */
	mov   r4, #0            /* r4 <- '0' */
	ldr   r5, =IIPM_LOCK    /* r5 <- ߥå֤γͥ٥ޥ */
	ldr   r6, =reqflg       /* r6 <- reqflg */
	ldr   r7, =lock_flag    /* r7 <- lock_flg */
	str   r4, [r7]          /* CPUå֤ */
ALABEL(dispatcher_2)
	/*
	 *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
	 *
	 *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
	 *  ߽ˤɤΥåȤȤβȡ
	 *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
	 *
	 *  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 *  ʬ˹Ԥʤɬפ롥
	 *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 *  ˤ⤫餺ץåԤˤʤäƤޤ
	 *  ARM-MǤϡPRIMASK򥻥åȤ֤WFIƤӽФȤǼ¸Ǥ롥
	 *  ξ֤ǳߤȡߤϼ¹Ԥ줺WFI꥿
	 *  뤳ȤˤʤΤǡöߤĤƳߥϥɥ¹Ԥ롥
	 *
	 *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
	 *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
	 *  ݤưͤ˹פʤʤ롥
	 *
	 *  åȤˤäƤϡϥ⡼˰ܹԤ뤿ᡤɸˡ
	 *  ۤʤ礬ɬפʾ礬롥
	 *  Τ褦ʥåȤǤϡåȰ¸ˤơTOPPERS_CUSTOM_IDLE
	 *  ֥ޥȤơtoppers_asm_custom_idle Ѱ
	 *  Ф褤
	 *
	 *  ʤtoppers_asm_custom_idle εҤˤäƤϡΥ쥸
	 *  toppers_asm_custom_idleǻѤ뤿ᡤ
	 *  toppers_asm_custom_idle ǻѤϡ¸뤳ȡ
	 *  Υ쥸 Calee saved 쥸Ǥ뤿ᡤ 
	 *  toppers_asm_custom_idle ȤƴؿƤӽФ򤷤ϡƤӽФ
	 *  ؿǼưŪ¸뤿ᡤ֥٥Ǥ¸ɬ
	 *  פʤ
	 *
	 *  쥸 : 
	 *   r4      : '0'
	 *   r5      : 'IIPM_LOCK'
	 *   r6      : reqflgΥɥ쥹
	 *   r7      : lock_flgΥɥ쥹
	 *   sp      : 󥿥ƥѤΥåƬɥ쥹(msp)
	 */
#ifdef TOPPERS_CUSTOM_IDLE
	toppers_asm_custom_idle
#else
	cpsid i               /* PRIMASK 򥻥å */
	msr   basepri, r4     /* ߵ */ 
	wfi
	cpsie i               /* PRIMASK 򥯥ꥢʳߤդ */
	msr   basepri, r5     /* CPUå֤ */ 
#endif /* TOPPERS_CUSTOM_IDLE */

	ldr   r0, [r6]        /* reqflgfalseʤdispatcher_2 */
	cmp   r0, #0
	beq   dispatcher_2
	str   r4, [r6]        /* reqflgfalse */

	/*
	 *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
	 *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
	 *  פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
	 *  ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
	 *  Ф褤
	 */
	mov   r0, #CONTROL_PSP  /* PSPͭ  */ 
	msr   control, r0      
	isb                     /* control ɬ */
	mov   r2, #1            /* lock_flagtrue */
	str   r2, [r7]
	ldr   r0, =saved_iipm   /* saved_iipm 0 */
	str   r4, [r0]
	b     dispatcher_0


/*
 *  ͥνλθƽФ
 *
 *  å󥿥ƥѤڤؤ
 *  
 */
	ATHUMB(call_exit_kernel)
	AGLOBAL(call_exit_kernel)
ALABEL(call_exit_kernel)
	mov   r0, #CONTROL_MSP
	msr   control, r0       /* MSPͭ  */
	isb                     /* control ɬ */
	ldr   r0, =exit_kernel  /* ͥνλƤ */
	bx    r0


/*
 *  ư
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
 *
 */ 
	ATHUMB(start_stask_r)
	AGLOBAL(start_stask_r)
ALABEL(start_stask_r)
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r1}  /* TCBΥɥ쥹 */
	bl      ovrtimer_start
	nop
	pop     {r1} /* TCBΥɥ쥹 */
#endif /* TOPPERS_SUPPORT_OVRHDR */
	mov   r0, #0
	ldr   r4, =lock_flag                    /* CPUå֤ */
	str   r0, [r4]
	msr   basepri, r0                       /* ߵ   */
	ldr   lr, =ext_tsk                      /*  */
	ldr   r2, [r1, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
	ldr   r0, [r2, #TINIB_exinf]            /* exinf쥸r0  */
	ldr   r1, [r2, #TINIB_task]             /* ưϤ˥ */
	bx    r1

	ATHUMB(start_utask_r)
	AGLOBAL(start_utask_r)
ALABEL(start_utask_r)
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r1}  /* TCBΥɥ쥹 */
	bl      ovrtimer_start
	nop
	pop     {r1} /* TCBΥɥ쥹 */
#endif /* TOPPERS_SUPPORT_OVRHDR */
	svc     #NO_UTASK_START
	nop

	/*
	 *  㳰Υ꥿ǥ桼⡼ɡߵĤȤʤꡢ
	 *  εưϤ˥פ褦˽
	 *  ˤϡhandler⡼ɤγߥå֤ǤFAULTMASK = 1
	 *  㳰Υ꥿ˤꡤߥåϲ
	 *  sspϽͤѹʤΤǡ㳰ե졼
	 *  ΤƤɬפϤʤ
	 */
	ATHUMB(start_utask_r_1)
	AGLOBAL(start_utask_r_1)
ALABEL(start_utask_r_1)
	mov     r0, #0
	ldr     r4, =lock_flag
	str     r0, [r4]                        /* CPUå */
	msr     basepri, r0                     /* ߵ */
	ldr     r4, [r1, #TCB_p_tinib]          /* r4 = p_runtsk->p_tinib */
	strb    r0, [r1, #TCB_priv_mode]        /* ø⡼ɼ¹Ԥȴ */
	ldr     r3, [r4, #TINIB_ustk_bottom]    /* r3 = 桼åݥ󥿤ν */
	mov     r0, #0x01                       /* 桼⡼ɤ˰ܹ */
	msr     control, r0
	ldr     r0, =call_ext_tsk               /* lr */
	orr     r0, r0, #0x01                   /* thumb⡼ */
	ldr     r1, [r4, #TINIB_task]           /* PC */
	ldr     r2, =EPSR_T                     /* xPSR(TӥåȤ'1'Ǥɬפ) */
	stmfd   r3!, {r0-r2}                    /* xPSR, PC, lrpspѤ */
	sub     r3, #(4*4)                      /* r12,r3,r2,r1Ѥޤʤ */
	ldr     r0, [r4, #TINIB_exinf]          /* r0 */
	stmfd   r3!, {r0}                       /* r0pspѤ */
	msr     psp, r3                         /* psp桼åݥ󥿤ǽ */
	bx      lr                              /* εưϤ */
	nop

	nop

	/*
	 *  ext_tsksvc̿ǸƤӽФ
	 */
	ASECTION(.text_shared)
	AALIGN(2)
	ATHUMB(call_ext_tsk)
	AGLOBAL(call_ext_tsk)
ALABEL(call_ext_tsk)
	mov     r4, #TFN_EXT_TSK
	svc     #NO_SVC
	nop
	mov     r4, #TFN_EXT_KER
	svc     #NO_SVC
	nop

/*
 *  svc٥ơ֥
 */
	AGLOBAL(svc_vector_tbl)
	ASECTION(.text_kernel)
ALABEL(svc_vector_tbl)
	ALONG  ret_int_r_4
	ALONG  start_utask_r_1
	ALONG  svc_entry
	ALONG  svc_entry_r_2
	ALONG  prepare_texrtn_utask
	ALONG  ret_tex
	ALONG  ret_tex_r

	/*
	 *  svc_entrysvc̿ǸƤӽФ
	 */
	ASECTION(.text_shared)
	AALIGN(2)
	ATHUMB(call_svc_entry)
	AGLOBAL(call_svc_entry)
ALABEL(call_svc_entry)
	push    {r5-r10,lr}
#if TOPPERS_FPU_CONTEXT
	/*
	 *  SVCμ¹ԤFPUƥȤ򥹥åѤޤʤ褦
	 *  CONTROL.FPCA򥯥ꥢ
	 */
	mrs     r8, control
	tst     r8, #CONTROL_FPCA           /*  FPUѤƤ?        */
	beq     call_svc_entry_0            /*  FPUѤƤ     */
	vpush   {s0-s31}                    /*  FPU쥸¸ -(32*4) */ 
	bic     r9, r8, #CONTROL_FPCA       /*  FPCAӥåȤȤ      */
	msr     control, r9                 /*  CONTROL쥸˽񤭹 */
	isb                                 /* control ɬ */
ALABEL(call_svc_entry_0)
	push    {r8, r9}                    /*  ȽѤCONTROL(r8)¸, r9ϥåĴΤΥߡ */
#endif /* TOPPERS_FPU_CONTEXT */
	mrs     r8, ipsr
	tst     r8, r8
	beq     call_svc_entry_1
	/*
	 *  ƤӽФߤ㳰
	 */
	stmfd   sp!, {r0-r3,r12}
	mrs     r9, control
	mov     r9, #0x00
	bl      svc_entry_1
	cpsie   f
	ldmfd   sp!, {r0-r3,r12}
	b       call_svc_entry_2
ALABEL(call_svc_entry_1)
	/*
	 *  ƤӽФߤ㳰Ǥʤ
	 */
	svc     #NO_SVC
ALABEL(call_svc_entry_2)
#if TOPPERS_FPU_CONTEXT
	pop     {r8, r9}                    /*  call_svc_entry¸CONTROL쥸   */
	tst     r8, #CONTROL_FPCA           /*  FPUѤƤ?                      */
	beq     call_svc_entry_3
	vpop    {s0-s31}                    /*  FPU쥸 -(32*4) */ 
ALABEL(call_svc_entry_3)
#endif /* TOPPERS_FPU_CONTEXT */
	pop     {r5-r10,lr}
	bx      lr

	/*
	 *  ӥν
	 *  ƤӽФ
	 *    Handler⡼
	 *    r4: func ID
	 */
	ATEXT
	AALIGN(2)
	ATHUMB(svc_entry)
	AGLOBAL(svc_entry)
ALABEL(svc_entry)
	ldr     r8, =p_runtsk   /* ¹Υ */
	ldr     r8, [r8]        /* ¹ΥTCB */
	/* 
	 *  R9: ƤӽФꤹ뤿Υӥåȥޥå
	 *    0x01: excnest_count == 0 && rundom != TACP_KERNEL
	 *    0x02: excnest_count == 0
	 */
	mov     r9, #0          /* 0 */

	/*
	 *  ƥȤθƤӽФå
	 */
	tst     lr, #EXC_RETURN_PSP /* 褬PSPǤʤ  */
	beq     svc_entry_1         /* 󥿥ƥȤθƽФʤХå */
	nop
	orr     r9, r9, #0x02       /* ƥȤΥӥåȤ򥻥å */

	/*
	 *  桼ɥᥤ󤫤θƤӽФå
	 *  ĥӥ¹ǤС
	 *  ͥɥᥤ󤫤θƤӽФȤʤΤǡ
	 *  svclevelΥåɬפʤ
	 *  svc̿ˤäơpspѤޤƤ
	 */
	mrs     r10, psp
	ldmfd   r10, {r0-r3,r12}             /*  */
	ldr     r6, =rundom
	ldr     r6, [r6]        /* r6 = rudom */
	tst     r6, r6          /* rundom == TACP_KERNEL(0) */
	beq     svc_entry_1     /* TACP_KERNELʤХå */
	orr     r9, r9, #0x01   /* rundom != TACP_KERNELΥӥåȤ򥻥å */

	/*
	 *  桼åȥƥॹåؤ
	 *  ξ֤ø⡼ɼ¹˰ܹԤ
	 *  褬ƥȤʤС¹ǤϤ
	 *  ʤΤǡp_runtskNULLɤΥåɬפʤϤ
	 */
	mov     r6, #0x00
	msr     control, r6                  /* ø⡼ɤذܹ */
	isb                                  /* control ɬ */
	str     r10, [r8, #TCB_usp]          /* usp¸ */
	ldr     r10, [r8, #TCB_ssp]          /* ssp */
	mov     r6, #0x01
	strb    r6, [r8, #TCB_priv_mode]

ALABEL(svc_entry_1)
	/*
	 *  ǽɤΥå
	 */
	cmp     r4, #TMIN_FNCD
	blt     svc_entry_7     /* ¤ⲼʤХ顼 */
	cmp     r4, #0 			/* ǽɤå(0 < r1) */
	ble     svc_entry_2     /* ӥξ */
	nop
	b       extsvc_entry   /* ĥӥξ */
	nop

ALABEL(svc_entry_2)
	/*
	 *  ƤӽФ󥿥ƥȤ
	 */
	tst     r9, #0x02       
	beq     svc_entry_3  /* 󥿥ƥȤʤХå */

	/*
	 *  svcΥ꥿
	 *  㳰ޥ֤
	 *  r10 = psp
	 */
	ldr     r6, =EPSR_T                 /* xPSR(TӥåȤ'1'Ǥɬפ) */
	ldr     r5, =svc_entry_4            
	stmfd   r10!, {r4-r6}                /* xPSR, pc, lrѤlrϥߡ */
	stmfd   r10!, {r0-r3,r12}            /* r0-r3,r12Ѥľ */
	msr     psp, r10
	bx      lr

ALABEL(svc_entry_3)
	cpsie   f
	ldmfd   sp, {r0-r3,r12}             /*  */
	push    {lr}                        /* EXC_RETURN¸ */

ALABEL(svc_entry_4)
	/*
	 *  ƥȤθƽФʤ
	 *    Thread⡼, PSP, ø⡼
	 */
	stmfd   sp!, {r12}      /* 5򥹥åѤ */

	/*
	 *  ӥΥơ֥
	 *  ӥΤƤ
	 */
	rsb     r4, r4, #0              /* ȿž */
	ldr     r5, =svc_table
	ldr     r5, [r5, r4, lsl #0x02] /* ơ֥ */
	blx     r5                      /* ӥ롼Ƥ */
	nop

	ldmfd   sp!, {r12}              /* 5򥹥å */

	/*
	 *  㳰ޥ֤
	 */
	cpsid   f

ALABEL(svc_entry_r)
	/*
	 *  ˤ㳰ޥ֤ǥפƤ
	 */
	/*
	 *  λǤγͥ٥ޥr3¸
	 *  chg_ipmloc_cpubasepri򹹿ؤб
	 */
	mrs     r3, basepri

	/*
	 *  褬ƥȤå
	 */
	tst     r9, #0x02       /* 󥿥ƥȤθƽФ */
	ittt    eq
	popeq   {lr}
	mrseq   r10, msp
	beq     svc_entry_r_4   /* ʤХå */

	/*
	 *  褬桼ɥᥤ󤫥å
	 *  ĥӥ¹ǤС
	 *  ϥͥɥᥤʤΤǡ
	 *  svclevelΥåɬפʤ
	 */
	tst     r9, #0x01       /* ͥɥᥤ󤫤θƽФ */
	beq     svc_entry_r_1   /* ʤХå */

	/*
	 *  Ԥػߤ
	 */
	ldrb    r1, [r8, #TCB_waifbd]
	bfc     r1, #TCB_waifbd_bit, #1
	strb    r1, [r8, #TCB_waifbd]

	/*
	 *  㳰¹Ծ郎äƤ뤫å
	 */
	ldrb    r1, [r8, #TCB_texptn]       /* α㳰װɽФ */
	cbz     r1, svc_entry_r_1           /* 0ʤ꥿ */
	ldrb    r1, [r8, #TCB_enatex]       /* 㳰ľ֤ɽФ */
	tst     r1, #TCB_enatex_mask        /* 㳰ػ߾֤ */
	beq     svc_entry_r_1               /* ػߤʤ꥿ */

	/*
	 *  ߥޥ֤ 
	 */
	ldr     r1, =ipmflg
	ldr     r1, [r1]
	cbz     r1, svc_entry_r_1   /* ipmflg == falseʤ꥿ */

	/*
	 *  ӥ뤫Υ꥿Υƥ֤CPUå֤
	 */
	ldr     r1, =lock_flag
	ldr     r1, [r1]
	cbnz    r1, svc_entry_r_1   /* CPUå֤ǤʤХ꥿ */

	/*
	 *  㳰ƤӽФ郎·äƤС
	 *  桼Υ㳰
	 *  r0 = p_runtsk
	 */
	stmfd   sp!, {r0,r3}    /* ֤ͤbasepri򥹥å¸ */
	mov     r0, r8
	cpsie   f
	svc     #NO_UTEX
	nop
	ldmfd   sp!, {r0,r3}    /* ֤ͤbasepri򥹥å */

ALABEL(svc_entry_r_1)
	cpsie   f
	svc     #NO_SVC_R

	ATHUMB(svc_entry_r_2)
	AGLOBAL(svc_entry_r_2)
ALABEL(svc_entry_r_2)
	/*
	 *  褬桼ɥᥤ󤫥å
	 */
	mrs     r10, psp
	add     r10, #EXC_FRAME_SIZE     /* åΤƤ   */
	tst     r9, #0x01               /* ͥɥᥤ󤫤θƽФ */
	beq     svc_entry_r_3           /* ʤХå */
	/* 
	 *  ø⡼ɼ¹Ԥȴ
	 */
	mov     r1, #0
	strb    r1, [r8, #TCB_priv_mode]
	/*
	 *  sstkustkؤ
	 *  ξ֤桼⡼ɼ¹˰ܹԤ
	 *  褬ƥȤʤС¹ǤϤ
	 *  ʤΤǡp_runtskNULLɤΥåɬפʤϤ
	 */
	mov     r1, #0x01
	msr     control, r1                 /* 桼⡼ɤذܹ */
	isb                                 /* control ɬ */
	str     r10, [r8, #TCB_ssp]         /* ssp¸ */
	ldr     r10, [r8, #TCB_usp]         /* usp */

ALABEL(svc_entry_r_3)
	msr     psp, r10     /* pspڤؤ */

ALABEL(svc_entry_r_4)
	str     r0, [r10]    /* ꥿spƬ֤֤ͤ */
	bx      lr          /* ƽФإ꥿ */
	nop

/*
 *  顼ˤ㳰ޥ֤ǥפƤ
 */
ALABEL(svc_entry_7)
	ldr     r0, =#E_RSFN    /* 顼ɤ֤ͤ */ 
	b       svc_entry_error_r
	nop

ALABEL(svc_entry_error_r)
	/*
	 *  褬ƥȤå
	 */
	tst     r9, #0x02       /* 󥿥ƥȤθƽФ */
	itt     eq
	mrseq   r10, msp
	beq     svc_entry_r_4   /* ʤsvc_entry_r_4 */

	/*
	 *  褬桼ɥᥤ󤫥å
	 *  r10 = sspǤꡤѤޤƤʤ
	 */
	tst     r9, #0x01               /* ͥɥᥤ󤫤θƽФ */
	beq     svc_entry_r_3           /* ʤХå */

	/* 
	 *  ø⡼ɼ¹Ԥȴ
	 */
	mov     r1, #0
	strb    r1, [r8, #TCB_priv_mode]
	/*
	 *  sstkustkؤ
	 *  ξ֤桼⡼ɼ¹˰ܹԤ
	 *  褬ƥȤʤС¹ǤϤ
	 *  ʤΤǡp_runtskNULLɤΥåɬפʤϤ
	 */
	mov     r1, #0x01
	msr     control, r1                 /* 桼⡼ɤذܹ */
	isb                                 /* control ɬ */
	str     r10, [r8, #TCB_ssp]         /* ssp¸ */
	ldr     r10, [r8, #TCB_usp]         /* usp */
    
	b       svc_entry_r_3

#define SVCINIB_svcrtn 0
#define SVCINIB_stksz  4

	ATHUMB(extsvc_entry)
	AGLOBAL(extsvc_entry)
ALABEL(extsvc_entry)
	/*
	 *  ǽɤΥå
	 */
	ldr     r5, =tmax_fncd
	ldr     r5, [r5]
	cmp     r4, r5                  /* ǽɤξ¥å(tmax_fncd < r4) */
	bgt     extsvc_error_RSFN       /* ¤򥪡ФƤʤХ顼 */
	
	/*
	 *  ĥӥΥơ֥
	 *  R3 = &svcinib
	 */
	ldr     r5, =svcinib_table
	sub     r4, r4, #1                  /* ǽ -= 1 */
	add     r5, r5, r4, lsl #3          /* offset = (ǽ - 1) << 3 (*=8) */

	/*
	 *  ĥӥΤΥɥ쥹NULLǤʤ
	 */
	ldr     r4, [r5, #SVCINIB_svcrtn]   /* R0 = svcinib->svcrtn */
	tst     r4, r4
	beq     extsvc_error_RSFN           /* NULLʤХ顼 */
	nop
	push    {r4}                        /* svcrtnistk¸ */
	
	/*
	 *  ƤӽФ󥿥ƥȤ
	 */
	mov     r4, #TDOM_KERNEL    /* ƤӽФTDOM_KERNEL */
	tst     r9, #0x02       
	beq     extsvc_entry_2  /* 󥿥ƥȤʤХå */

	/*
	 *  åλ̤å
	 *  r10 = ssp
	 */
	ldr     r4, [r8, #TCB_p_tinib]          /* r4 = p_runtsk->tinib */
	ldr     r6, [r4, #TINIB_sstk_bottom]    /* r6 = sstkΥɥ쥹 */
	subs    r6, r6, r10                     /* r6 = sstk_bottom - ssp */
	blo     extsvc_error_NOMEM              /* r6 < r10 ʤХ顼 */
	ldr     r5, [r5, #SVCINIB_stksz]        /* R4 = svcinib->stksz */
	add     r6, r6, r5                      /* r6 = r6 + Ѥ륹å */
	bvs     extsvc_error_NOMEM              /* Хե饨顼 */
	ldr     r5, [r4, #TINIB_sstksz]         /* r4 = sstkΥ */
	cmp     r6, r5                          /* r6 <= r5  */
	bhi     extsvc_error_NOMEM              /* ǤʤХ顼 */
	nop

	/*
	 *  svclevel򥤥󥯥
	 */
	ldrb    r5, [r8, #TCB_svclevel] /* svclevelɤ߹ */
	cmp     r5, #255                /* svclevelξ¥å */
	bhs     extsvc_error_SYS        /* ͥȤξ¤ä票顼 */
	add     r5, r5, #1              /* svclevel += 1 */
	strb    r5, [r8, #TCB_svclevel] /* svclevel򹹿 */

	/*
	 *  ¹ԥɥᥤ򥫡ͥɥᥤ
	 */
	mov     r6, #TDOM_KERNEL    /* ƤӽФTDOM_KERNEL */
	tst     r9, #0x01           /* rundom != TACP_KERNEL  */
	beq     extsvc_entry_1      /* ͥɥᥤʤХå */
	ldr     r5, =rundom
	mov     r6, #0x00
	str     r6, [r5]            /* rundom = TACP_KERNEL */

	/*
	 *  domid
	 */
	ldr     r5, [r4, #TINIB_p_dominib]  /* R5 = p_dominib */
	ldr     r4, =dominib_table          /* R4 = dominib_table */
	sub     r4, r5, r4                  /* R4 = &dominib_table[x] - &dominib_table[0] */
	/*
	 *  dominibΥ8byte
	 */
	/*
	 *  R0 = 8x 
	 *  => 8x / 8 = x
	 *  3bitե
	 */
	asr     r4, #3
	add     r6, r4, #TMIN_DOMID
	nop

ALABEL(extsvc_entry_1)
	mov     r4, r6
	/*
	 *  svcΥ꥿
	 *  㳰ޥ֤
	 *  r0-r3, r12
	 */
	ldr     r6, =EPSR_T                 /* xPSR(TӥåȤ'1'Ǥɬפ) */
	ldr     r5, =extsvc_entry_3            
	stmfd   r10!, {r4-r6}                /* xPSR, pc, lrѤlrϥߡ */
	stmfd   r10!, {r0-r3,r12}            /* r0-r3,r12Ѥľ */
	msr     psp, r10
	pop     {r6}                        /* svcrtn */
	bx      lr

ALABEL(extsvc_entry_2)
	cpsie   f
	pop     {r6}                        /* svcrtn */
	ldmfd   sp, {r0-r3,r12}             /*  */
	push    {lr}                        /* EXC_RETURN¸ */

ALABEL(extsvc_entry_3)
	/*
	 *  ƥȤθƽФʤ
	 *    Thread⡼, PSP, ø⡼
	 */
	stmfd   sp!, {r4}           /* ƤӽФdomid5򥹥åѤ */
	stmfd   sp!, {r12}          /* ƤӽФdomid5򥹥åѤ */

	/*
	 *  ĥӥΤƤ
	 */
	blx     r6                  /* ӥ롼Ƥ */
	nop
	ldmfd   sp!, {r1,r2}        /* ƤӽФdomid5򥹥å */

	/*
	 *  㳰ޥ֤
	 */
	cpsid   f

ALABEL(extsvc_entry_r)
	/*
	 *  ˤ㳰ޥ֤ǥפƤ
	 */
	/*
	 *  λǤγͥ٥ޥr3¸
	 *  chg_ipmloc_cpubasepri򹹿ؤб
	 */
	mrs     r3, basepri

	/*
	 *  ƤӽФ󥿥ƥȤ
	 */
	mrs     r10, msp
	tst     r9, #0x02       /* 󥿥ƥȤθƽФ */
	itt     eq
	popeq   {lr}
	addeq   r10, r10, #4    /* popʬĴ */
	beq     svc_entry_r_4   /* ʤХå */

	/*
	 *  svclevelǥ
	 */
	ldrb    r1, [r8, #TCB_svclevel] /* svclevelɤ߹ */
	sub     r1, r1, #1              /* svclevel -= 1 */
	strb    r1, [r8, #TCB_svclevel] /* svclevel򹹿 */
	tst     r1, r1
	bne     svc_entry_r_1           /* svclevel == 0ǤʤХ꥿ */

	/*
	 *  ¹ԥɥᥤ°ɥᥤ᤹
	 */
	ldr     r1, [r8, #TCB_p_tinib]      /* ֥åɤ߽Ф */
	ldr     r1, [r1, #TINIB_p_dominib]  /* ɥᥤ֥åɤ߽Ф */
	ldr     r1, [r1, #DOMINIB_domptn]   /* °ɥᥤμ */
	ldr     r2, =rundom                 /* R2 = &rundom */
	str     r1, [r2]                    /* rundom = °ɥᥤ */
	/*
	 *  ӥ¹˳ĥӥ뤳ȤϤʤᡢ
	 *  ꥿褬󥿥ƥȤǤʤʤС꥿
	 *  㳰α֤ǤϤʤ
	 */

	/*
	 *  Ԥػ߾֤
	 */
	ldrb    r1, [r8, #TCB_waifbd]
	bfc     r1, #TCB_waifbd_bit, #1
	strb    r1, [r8, #TCB_waifbd]

	/*
	 *  㳰¹Ծ郎äƤ뤫å
	 */
	ldrb    r1, [r8, #TCB_texptn]       /* α㳰װɽФ */
	tst     r1, r1
	beq     svc_entry_r_1               /* 0ʤ꥿ */
	ldrb    r1, [r8, #TCB_enatex]       /* 㳰ľ֤ɽФ */
	tst     r1, #TCB_enatex_mask        /* 㳰ػ߾֤ */
	beq     svc_entry_r_1               /* ػߤʤ꥿ */

	/*
	 *  ߥޥ֤ 
	 */
	ldr     r1, =ipmflg
	ldr     r1, [r1]
	tst     r1, r1
	beq     svc_entry_r_1   /* ipmflg == falseʤ꥿ */

	/*
	 *  ӥ뤫Υ꥿Υƥ֤CPUå֤
	 */
	ldr     r1, =lock_flag
	ldr     r1, [r1]
	tst     r1, r1
	bne     svc_entry_r_1   /* CPUå֤ǤʤХ꥿ */

	/*
	 *  褬桼ɥᥤ󤫥å
	 */
	tst     r9, #0x01           /* ƤӽФΥɥᥤ == TACP_KERNEL */
	bne     extsvc_usr_r_texrtn

ALABEL(extsvc_prv_r_texrtn)
	/*
	 *  CPUå
	 */
	ldr     r2, =#IIPM_LOCK
	msr     basepri, r2
	ldr     r1, =lock_flag
	mov     r2, #0x01
	str     r2, [r1]
	ldr     r1, =saved_iipm
	mov     r2, #IIPM_ENAALL
	str     r2, [r1]

	stmfd   sp!, {r0,r3}    /* ֤ͤbasepri򥹥å¸ */

	/*
	 *  㳰ޥֲ
	 */
	cpsie   f

	/* 
	 *  ƥॿѤΥ㳰
	 */
	bl      call_texrtn_stask
	nop

	/*
	 *  㳰ޥ֤
	 */
	cpsid   f
	ldmfd   sp!, {r0,r3}    /* ֤ͤbasepri򥹥åˤ */

	/*
	 *  ꥿CPUåͥ٥ޥȤʤ褦
	 *  
	 *  call_texrtn_staskνиipmflgtrueˤʤäƤꡤޤ
	 *  νиǥǥѥåƤ⡤Υǥѥå
	 *  ǤϡipmflgtrueǤ뤿ᡤlock_flagbasepri
	 */
	ldr     r1, =lock_flag
	mov     r2, #0
	str     r2, [r1]
	ldr     r2, =#IIPM_ENAALL
	msr     basepri, r2
	b       svc_entry_r_1   /* ꥿ */
	nop

ALABEL(extsvc_usr_r_texrtn)
	stmfd   sp!, {r0,r3}    /* ֤ͤbasepri򥹥å¸ */
	mov     r0, r8          /* r0 = p_runtsk */
	cpsie   f
	svc     #NO_UTEX        /* 桼ѤΥ㳰 */
	nop
	ldmfd   sp!, {r0,r3}    /* ֤ͤbasepri򥹥å */
	b       svc_entry_r_1   /* ꥿ */
	nop

ALABEL(extsvc_error_RSFN)
	ldr     r0, =#E_RSFN    /* 顼ɤ֤ */
	b       svc_entry_error_r
	nop
ALABEL(extsvc_error_NOMEM)
	ldr     r0, =#E_NOMEM   /* 顼ɤ֤ */
	pop     {r6}            /* svcrtn򥹥å */
	b       svc_entry_error_r
	nop
ALABEL(extsvc_error_SYS)
	ldr     r0, =#E_SYS     /* 顼ɤ֤ */
	pop     {r6}            /* svcrtn򥹥å */
	b       svc_entry_error_r
	nop

	/*
	 *  桼Υ㳰롼
	 *  ƽФ
	 *  - Handler⡼
	 *  - FAULTMASK = 1
	 *  - ø⡼ɡCONTROL[0] == 0
	 *  - psp = sstk
	 *  - R0 = p_runtsk
	 */
	ATHUMB(prepare_texrtn_utask)
	AGLOBAL(prepare_texrtn_utask)
ALABEL(prepare_texrtn_utask)
	push    {r4-r6}                         /* ret_tex */
	/*
	 *  桼åλ̤å
	 *  uspθ
	 *  ø⡼ɻ˻Ѥ륵
	 *    㳰ΤǻѤʬˤĤƤϡ
	 *    桼⡼ɤǼ¹Ԥ뤿ᡤ
	 *    ¹Ի˥åХե򸡽ФǤ
	 */
	ldr     r1, [r0, #TCB_p_tinib]          /* r1 = p_runtsk->tinib */
	ldr     r3, [r1, #TINIB_ustk_bottom]    /* r3 = 桼åΥɥ쥹 */
	ldr     r2, [r0, #TCB_usp]              /* r2 = usp */
	subs    r3, r3, r2                      /* r3 = ustk_bottom - usp */
	blo     error_nomem_texrtn              /* r3 < r2 ʤХ顼 */
	add     r3, r3, #USRTEX_STKSZ           /* r3 = r3 + Ѥ륹å */
	bvs     error_nomem_texrtn              /* Хե饨顼 */
	ldr     r4, [r1, #TINIB_ustksz]         /* r4 = 桼åΥ */
	cmp     r3, r4                          /* r3 <= r4  */
	bhi     error_nomem_texrtn              /* ǤʤХ顼 */
	nop

	/* 
	 *  桼åؤ
	 *   ǥѥåػ߾֡disdsp   <- new usp
	 *                                  <- old usp
	 */
	ldr     r4, =disdsp         /* r4 = &disdsp */
	ldr     r4, [r4]            /* r4 = disdsp */
	stmfd   r2!, {r4}        /* 桼å */
	str     r2, [r0, #TCB_usp]  /* uspΥå */

	/*
	 * R0 = p_runtsk
	 * R1 = p_tinib
	 * R2 = usp
	 */
ALABEL(prepare_texrtn_utask_r)
	/*
	 *  ø⡼ɤƥ㳰롼إ
	 */
	/*
	 *  㳰롼Υɥ쥹
	 *  㳰롼󤫤Ϥcall_ret_tex˻
	 */
	ldr     r5, =EPSR_T                 /* xPSR(TӥåȤ'1'Ǥɬפ) */
	ldr     r4, [r1, #TINIB_texrtn]
	ldr     r3, =call_ret_tex
	orr     r3, r3, #0x01       /* thumb⡼ */
	stmfd   r2!, {r3-r5}        /* 桼å */

	/*
	 *  㳰롼ΰ
	 */
	/* 1R0 = p_runtsk->texptn */
	/* 2R1 = p_runtsk->p_tinib->exinf */
	ldr     r3, [r0, #TCB_texptn]       /* 㳰ѥ */
	ldr     r4, [r1, #TINIB_exinf]      /* ĥ */
	stmfd   r2!, {r3-r6,r12}            /* 桼år0,r1ʳϥߡ */

	/*
	 *  桼åؤڤؤ
	 */
	mrs     r1, psp
	str     r1, [r0, #TCB_ssp]          /* ssp¸ */
	msr     psp, r2

	/* 
	 *  ø⡼ɼ¹Ԥȴ
	 */
	mov     r1, #0x01
	msr     control, r1
	isb                                 /* control ɬ */
	mov     r1, #0
	strb    r1, [r0, #TCB_priv_mode]    

	str     r1, [r0, #TCB_texptn]       /* p_runtsk->texptn = 0 */
	/* 
	 *  p_runtsk->enatex = false
	 */
	ldrb    r1, [r0, #TCB_enatex]
	bfc     r1, #TCB_enatex_bit, #1
	strb    r1,	[r0, #TCB_enatex]       /* p_runtsk->enatex = false */

	bx      lr                          /* 㳰Υ꥿ˤäƥ㳰 */
	nop
	/*
	 *  㳰¹Գϻå㳰ϥɥƤӽФ
	 */
ALABEL(error_nomem_texrtn)
	/*
	 *  ߥ졼Ȥ줿CPU㳰Ƥ
	 *  㳰Υ꥿prepare_texrtn_utaskθƤӽФ
	 */
	mrs   r0, psp                /* ܤγߤξPSP */
	mrs   r2, basepri             /* baepriͤ */
	stmfd r0!,{r2}               /* ȯγͥ٥ޥѤ */
	stmfd r0!,{lr}               /* EXC_RETURN Ѥ             */
	msr   psp, r0                /* CPU㳰ϥɥؤΰȤʤ */
	push  {lr}                   /* MSPˤEXC_RETURN Ѥ    */ 
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r0}
	bl      ovrtimer_stop
	pop     {r0}
#endif /* TOPPERS_SUPPORT_OVRHDR */
	 ldr     r3, =#EXCNO_EMU_TEXRTN
	 cpsie   f
	 b       core_exc_entry_3
	 nop
	 /*
	  *  ˤϤʤϤ
	  */
ALABEL(error_nomem_texrtn_loop)
	b       error_nomem_texrtn_loop
	nop

	/*
	 *  ret_texext_tskext_kersvc̿ǸƤӽФ
	 */
	ASECTION(.text_shared)
	AALIGN(2)
	ATHUMB(call_ret_tex)
	AGLOBAL(call_ret_tex)
ALABEL(call_ret_tex)
	svc     #NO_RET_TEX
	nop
	mov     r4, #TFN_EXT_TSK
	svc     #NO_SVC
	nop
	mov     r4, #TFN_EXT_KER
	svc     #NO_SVC
	nop


#define ACVCT_ACPTN1 0
#define USTK_disdsp  0

	/*
	 *  㳰νи
	 *  ƤӽФξ
	 *    ƥॹå
	 */
	ASECTION(.text_kernel)
	AALIGN(2)
	ATHUMB(ret_tex)
	AGLOBAL(ret_tex)
ALABEL(ret_tex)
	/*
	 *  󥿥ƥȤθƤӽФʤХ顼
	 */
	tst     lr, #EXC_RETURN_PSP /* 褬PSPǤʤ  */
	bne     ret_tex_0
	bx      lr                  /* 󥿥ƥȤθƽФʤХ꥿ */

ALABEL(ret_tex_0)
	/*
	 *  ƽФø⡼ɤʤХ顼
	 *  CONTROLå
	 */
	mrs     r0, control
	tst     r0, #0x01
	bne     ret_tex_1
	bx      lr              /* ø⡼ɤθƽФʤХ꥿ */
	nop

ALABEL(ret_tex_1)
	/*
	 *  r0 = p_runtsk
	 */
	ldr     r0, =p_runtsk
	ldr     r0, [r0]
	/*
	 *  桼åλ̤å
	 *  uspθ
	 *  ø⡼ɻ˻Ѥ륵
	 *    㳰ǥ桼å줿ؤб
	 */
	ldr     r1, [r0, #TCB_p_tinib]          /* r1 = p_runtsk->tinib */
	ldr     r3, [r1, #TINIB_ustk_bottom]    /* r3 = 桼åΥɥ쥹 */
	ldr     r4, [r1, #TINIB_ustksz]         /* r4 = 桼åΥ */
	subs    r4, r3, r4                      /* r4 = ustk_bottom - ustksz */
	blo     error_nomem_ret_tex             /* r3 < r4 ʤХ顼 */
	mrs     r2, psp                         /* r2 = usp */
	cmp     r2, r4                          /* r4 > r2 ʤ */
	blo     error_nomem_ret_tex             /* 顼 */
	add     r4, r2, #(EXC_FRAME_SIZE+1*4)   /* r4 = usp */
	bvs     error_nomem_texrtn              /* Хե饨顼 */
	cmp     r3, r4                          /* r3 < r4 ʤ */
	blo     error_nomem_texrtn              /* 顼 */
	add     r2, #EXC_FRAME_SIZE             /* åΤƤ */
	nop

	/*
	 *  λǡr2 = usp
	 */
	str     r2, [r0, #TCB_usp]          /* usp¸ */
	ldr     r6, [r0, #TCB_ssp]          /* psp = ssp */
	msr     psp, r6
	/* 
	 *  p_runtsk->priv_mode = true
	 */
	mov     r1, #1
	strb    r1, [r0, #TCB_priv_mode]    
	mov     r1, #0x00
	msr     control, r1
	isb                 /* control ɬ */

	/*
	 *  r3 = rundom
	 */
	ldr     r3, =rundom
	ldr     r3, [r3]

	/*
	 *  CPUå
	 *  ipm
	 *    㳰顤CPUåͥ٥ޥ
	 *    ѹޤޥ꥿󤷤ؤк
	 */
	/*
	 *  ꥿Υƥ֤CPUå֤Ȥ
	 */
	ldr     r5, =lock_flag
	mov     r1, #0
	str     r1, [r5]
	/*
	 *  basepriΥå
	 */
	ldr     r5, =#IIPM_ENAALL
	msr     basepri, r5
	/*
	 *  ipmflgtrueˤ
	 */
	ldr     r5, =ipmflg
	mov     r1, #1
	str     r1, [r5]

ALABEL(ret_tex_2)
	/*
	 *  disdsp桼å
	 *    㳰顤ǥѥåػߤޤ
	 *    ꥿󤷤ؤк
	 */
	ldr     r1, =disdsp
	ldr     r4, =sysstat_acvct
	ldr     r4, [r4, #ACVCT_ACPTN1]
	tst     r4, r3                  /* sysstat_acvct.acptn1 & rundom == 0? */
	beq     ret_tex_3
	/*
	 *  disdsp桼å
	 */
	ldr     r3, [r2, #USTK_disdsp]
	str     r3, [r1]

ALABEL(ret_tex_3)
	/*
	 *  dspflg򹹿
	 *  ͥ٥ޥ֤ΤϤʤΤǡ
	 *  disdspΤߤȽǤФ褤
	 *  㳰CPUåͥ٥ޥ
	 *  åȤ줿ˤdspflgѲ뤿ᡤ
	 *  dspflg򹹿ɬפΤϡdisdsp᤹
	 *  Ǥʤ
	 */
	ldr     r3, [r1]
	eor     r3, r3, #1
	ldr     r1, =dspflg
	str     r3, [r1]

	/*
	 *  p_runtsk->enatex = false
	 */
	ldrb    r1, [r0, #TCB_enatex]
	bfc     r1, #TCB_enatex_bit, #1
	strb    r1, [r0, #TCB_enatex]
	
	/*
	 *  dspflgtrue
	 */
	ldr     r3, =dspflg
	ldr     r3, [r3]
	tst     r3, r3      /* dspflg == false? */
	beq     ret_tex_r_1 /* falseʤǥѥåʤ */
	/*
	 *  p_runtsk != p_schedtsk 
	 */
	ldr     r3, =p_schedtsk     /* r3 <- schedtsk */
	ldr     r3, [r3]
	cmp     r0, r3              /* runtsk  schedtsk  */
	beq     ret_tex_r_1         /* Ʊʤǥѥåʤ */
	/*
	 *  CPUå֤
	 */
	/*
	 *  basepriΥå
	 *  ͥγߤػ
	 */
	ldr     r3, =#IIPM_LOCK
	msr     basepri, r3
	
	ldr     r4, =lock_flag
	mov     r1, #0
	str     r1, [r4]
	
	ldr     r4, =saved_iipm
	ldr     r1, =#IIPM_ENAALL
	str     r1, [r4]
	
	ldr     r5, =EPSR_T                 /* xPSR(TӥåȤ'1'Ǥɬפ) */
	ldr     r4, =ret_tex_4
	stmfd   r6!, {r4-r5}
	sub     r6, r6, #(EXC_FRAME_SIZE - (2*4))
	msr     psp, r6
	bx      lr

ALABEL(ret_tex_4)
	/*
	 *  dispatch
	 */
	bl      dispatch
	nop
	svc     #NO_RET_TEX_R     
	nop

	ATHUMB(ret_tex_r)
	AGLOBAL(ret_tex_r)
ALABEL(ret_tex_r)
	mrs     r6, psp
	add     r6, r6, #EXC_FRAME_SIZE
	msr     psp, r6
	/*
	 *  ꥿Υƥ֤CPUå֤Ȥ
	 */
	ldr     r1, =lock_flag
	mov     r0, #0
	str     r0, [r1]
	/*
	 *  basepriΥå
	 */
	ldr     r3, =#IIPM_ENAALL
	msr     basepri, r3

ALABEL(ret_tex_r_1)
	/*
	 *  α㳰װ뤫å
	 */
	ldr     r0, =p_runtsk
	ldr     r0, [r0]
	ldr     r2, [r0, #TCB_usp]          /* uspɽФ */
	ldr     r3, [r0, #TCB_texptn]       /* α㳰װɽФ */
	tst     r3, r3                      /* 0ǤʤtexrtnƼ¹ */
	itt     ne
	ldrne   r1, [r0, #TCB_p_tinib]      /* r1 = p_runtsk->tinib */
	bne     prepare_texrtn_utask_r      /* 0ǤʤtexrtnƼ¹ */
	nop
	
	add     r2, r2, #1*4        /* r2(usp)ΤƤ */
	str     r2, [r0, #TCB_usp]  /* usp᤹ */
	
	/*
	 *  p_runtsk->enatex = true
	 */
	ldrb    r1, [r0, #TCB_enatex]   /* 㳰ľ֤ɽФ */
	mov     r2, #TCB_enatex_mask
	orr     r1, r1, r2
	strb    r1, [r0, #TCB_enatex]
	
	pop     {r4-r6}                 /* prepare_texrtnƬ¸쥸 */
	bx      lr                      /* prepare_texrtnθƽФإ꥿ */
	nop

	/*
	 *  㳰꥿å㳰ϥɥƤӽФ
	 */
ALABEL(error_nomem_ret_tex)
	/*
	 *  ߥ졼Ȥ줿CPU㳰Ƥ
	 *  㳰Υ꥿ret_texθƤӽФ
	 *  TODO: 㳰꥿󤷤ư
	 */
	mrs   r0, psp                /* ܤγߤξPSP */
	mrs   r2, basepri             /* baepriͤ */
	stmfd r0!,{r2}               /* ȯγͥ٥ޥѤ */
	stmfd r0!,{lr}               /* EXC_RETURN Ѥ             */
	msr   psp, r0                /* CPU㳰ϥɥؤΰȤʤ */
	push  {lr}                   /* MSPˤEXC_RETURN Ѥ    */ 
#ifdef TOPPERS_SUPPORT_OVRHDR
	push    {r0}
	bl      ovrtimer_stop
	pop     {r0}
#endif /* TOPPERS_SUPPORT_OVRHDR */
	ldr     r3, =#EXCNO_EMU_RET_TEX
	cpsie   f
	b       core_exc_entry_3
	nop
	/*
	 *  ˤϤʤϤ
	 */
ALABEL(error_nomem_ret_tex_loop)
	b     error_nomem_ret_tex_loop
	nop

/*
 *  Ԥ
 */
	AALIGN(2)
	ATEXT
	ATHUMB(sil_dly_nse)
	AGLOBAL(sil_dly_nse)
ALABEL(sil_dly_nse)
	sub   r0, r0, #SIL_DLY_TIM1
	cmp   r0, #0
	bgt   sil_dly_nse1
	bx    lr
ALABEL(sil_dly_nse1)
	sub   r0, r0, #SIL_DLY_TIM2
	cmp   r0, #0
	bgt   sil_dly_nse1
	bx    lr

