/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: test_lib.h 1027 2015-02-08 10:27:44Z ertl-hiro $
 */

/* 
 *		ƥȥץѥ饤֥
 */

#ifndef TOPPERS_TEST_LIB_H
#define TOPPERS_TEST_LIB_H

#ifdef __cplusplus
extern "C" {
#endif

#include <t_syslog.h>
#include <extsvc_fncode.h>

/*
 *  åȰ¸
 */
#include "target_syssvc.h"
#include "target_test.h"

/*
 *  ƥȥץѥ饤֥γĥӥΥå
 */ 
#ifndef SSZ_TEST_CHECK_POINT
#define SSZ_TEST_CHECK_POINT	1024
#endif /* SSZ_TEST_CHECK_POINT */

#ifndef SSZ_TEST_CHECK_ASSERT_ERROR
#define SSZ_TEST_CHECK_ASSERT_ERROR	1024
#endif /* SSZ_TEST_CHECK_ASSERT_ERROR */

#ifndef SSZ_TEST_CHECK_ERCD_ERROR
#define SSZ_TEST_CHECK_ERCD_ERROR	1024
#endif /* SSZ_TEST_CHECK_ERCD_ERROR */

#ifndef SSZ_TEST_SET_BIT_FUNC
#define SSZ_TEST_SET_BIT_FUNC	1024
#endif /* SSZ_TEST_SET_BIT_FUNC */

#ifndef SSZ_TEST_SYSLOG_FLUSH
#define SSZ_TEST_SYSLOG_FLUSH	1024
#endif /* SSZ_TEST_SYSLOG_FLUSH */

#ifndef SSZ_TEST_TEST_FINISH
#define SSZ_TEST_TEST_FINISH	1024
#endif /* SSZ_TEST_TEST_FINISH */

/*
 *	ʿǴؿη
 */
typedef ER (*BIT_FUNC)(void);

/*
 *  ƥȥץѥ饤֥γĥӥˤƽФ
 *  ե
 */
#ifndef TOPPERS_SVC_CALL

/*
 *	åݥ
 */
Inline void
check_point(uint_t count)
{
	(void) cal_svc(TFN_TEST_CHECK_POINT, (intptr_t) count, 0, 0, 0, 0);
}

/*
 *	å顼
 */
Inline void
check_assert_error(const char *expr, const char *file, int_t line)
{
	(void) cal_svc(TFN_TEST_CHECK_ASSERT_ERROR, (intptr_t) expr,
									(intptr_t) file, (intptr_t) line, 0, 0);
}

/*
 *	顼ɥå顼
 */
Inline void
check_ercd_error(ER ercd, const char *file, int_t line)
{
	(void) cal_svc(TFN_TEST_CHECK_ERCD_ERROR, (intptr_t) ercd,
									(intptr_t) file, (intptr_t) line, 0, 0);
}

/*
 *	ʿǴؿ
 */
Inline void
set_bit_func(BIT_FUNC bit_func)
{
	(void) cal_svc(TFN_TEST_SET_BIT_FUNC, (intptr_t) bit_func, 0, 0, 0, 0);
}

/*
 *  ƥνϽ
 */
Inline void
syslog_flush(void)
{
	(void) cal_svc(TFN_TEST_SYSLOG_FLUSH, 0, 0, 0, 0, 0);
}

/*
 *	ƥȥץνλ
 */
Inline void
test_finish(void)
{
	(void) cal_svc(TFN_TEST_TEST_FINISH, 0, 0, 0, 0, 0);
}

#endif /* TOPPERS_SVC_CALL */

/*
 *  ƥȥץѥ饤֥δؿƽФˤƽФ󥿥ե
 */
extern void	_test_check_point(uint_t count) throw();
extern void _test_check_assert_error(const char *expr,
							 const char *file, int_t line) throw();
extern void _test_check_ercd_error(ER ercd,
							 const char *file, int_t line) throw();
extern void	_test_set_bit_func(BIT_FUNC bit_func) throw();
extern void	_test_syslog_flush(void) throw();
extern void	_test_test_finish(void) throw();

#ifdef TOPPERS_SVC_CALL
#define check_point			_test_check_point
#define check_assert_error	_test_check_assert_error
#define check_ercd_error	_test_check_ercd_error
#define set_bit_func		_test_set_bit_func
#define syslog_flush		_test_syslog_flush
#define test_finish			_test_test_finish
#endif /* TOPPERS_SVC_CALL */

/*
 *  ƥȥץγ
 */
Inline void
test_start(char *progname)
{
	syslog_1(LOG_NOTICE, "Test program: %s", progname);
}

/*
 *	λåݥ
 */
Inline void
check_finish(uint_t count)
{
	check_point(count);
	syslog_0(LOG_NOTICE, "All check points passed.");
	test_finish();
}

/*
 *	å
 */
#define check_assert(exp) \
	((void)(!(exp) ? (check_assert_error(#exp, __FILE__, __LINE__), 0) : 0))

/*
 *	顼ɥå
 */
#define check_ercd(ercd, expected_ercd) \
	((void)((ercd) != (expected_ercd) ? \
					(check_ercd_error(ercd, __FILE__, __LINE__), 0) : 0))

/*
 *	ƥ֤Υåʥƥѡ
 *
 *  ƥ֤Ф뻲ĤƤʤϡδ
 *  Ѥ뤳ȤϤǤʤ󥿥ƥѤΥƥ֤
 *  åcheck_state_iˤѤ뤳ȤϤǤ롥
 */
Inline void
check_state(bool_t ctx, bool_t loc, PRI ipm, bool_t dsp,
										bool_t dpn, bool_t tex)
{
	PRI		intpri;
	ER		ercd;

	check_assert(sns_ctx() == ctx);
	check_assert(sns_loc() == loc);
	if (!loc) {
		/*
		 *  IPMΥåϡCPUå֤ξˤΤ߹Ԥ
		 */
		ercd = get_ipm(&intpri);
		check_ercd(ercd, E_OK);
		check_assert(intpri == ipm);
	}
	check_assert(sns_dsp() == dsp);
	check_assert(sns_dpn() == dpn);
	check_assert(sns_tex() == tex);
}

/*
 *	ƥ֤Υå󥿥ƥѡ
 */
Inline void
check_state_i(bool_t ctx, bool_t loc, bool_t dsp, bool_t dpn, bool_t tex)
{
	check_assert(sns_ctx() == ctx);
	check_assert(sns_loc() == loc);
	check_assert(sns_dsp() == dsp);
	check_assert(sns_dpn() == dpn);
	check_assert(sns_tex() == tex);
}

/*
 *  ƥȥץѥ饤֥ĥӥȤϿ뤿
 *  
 */
extern ER_UINT	extsvc_check_point(intptr_t count, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_check_assert_error(intptr_t expr, intptr_t file,
									intptr_t line, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_check_ercd_error(intptr_t ercd, intptr_t file,
									intptr_t line, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_set_bit_func(intptr_t bit_func, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_flush(intptr_t par1, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_test_finish(intptr_t par1, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_TEST_LIB_H */
