/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 * åȰ¸⥸塼STM32P207ѡ
 */
#include "kernel_impl.h"
#include <sil.h>
#include "stm32p207.h"
#include "usart.h"
#include "task.h"
#include "memory.h"

/*
 * åȰ¸
 */
void
target_initialize(void)
{
	/*
	 *  ץåå(RCC)ν
	 */
	/* HSIͭ */
	sil_orw((void*)RCC_CR, CR_HSI_ON);

    /* CFGRΥꥻå */
    sil_wrw_mem((void *)RCC_CFGR, 0x00000000);

	/* HSEON, CSSON, PLLON Υꥢ */
	sil_andw((void*)RCC_CR, 0xFEF6FFFF);

    /* PLLCFGRΥꥻå */
    sil_wrw_mem((void *)RCC_PLLCFGR, 0x00000000);

	/* HSEBYP Υꥢ */
	sil_andw((void*)RCC_CR, 0xFFFBFFFF);

	/* ߶ػ */
    sil_wrw_mem((void *)RCC_CIR, 0x00000000);

	/*
	 *  120Mhz
	 */
	/* HSEͭ */
	sil_orw((void*)RCC_CR, CR_HSE_ON);

	/* HSEͭԤ */
	while((sil_rew_mem((void*)RCC_CR) & CR_HSE_RDY) == 0);

	/* HCLK = SYSCLK, PCLK2 = HCLK, PCLK1 = HCLK/2  */
	sil_orw((void*)RCC_CFGR, (0x00 << 4) | (0x00 << 13) | (0x04 << 10));

	/* PLLCLK = (25MHz * (PLLN / PLLM)) / PLLP = (25MHz * (48 / 5)) / 2 = 120MHz, HSE as PLL clock */
    sil_wrw_mem((void *)(RCC_PLLCFGR), (CFGR_PLL_SRC | (0x00 << 16) | (48 << 6) | (5 << 0)));

	/* PLLͭ */
	sil_orw((void*)RCC_CR, CR_PLL_ON);

	/* PLLͭԤ */
	while((sil_rew_mem((void*)RCC_CR) & CR_PLL_RDY) == 0);

	/* FLASH ROM Υ쥤ƥ󥷤 */
	sil_andw((void*)FLASH_ACR, ~ACR_LATENCY_MASK);
	sil_orw((void*)FLASH_ACR, ACR_LATENCY_THREE);

	/* FLASH ROMΥץեåХåեDå塢Iåѡ */
	sil_andw((void*)FLASH_ACR, ~(ACR_DCEN | ACR_ICEN | ACR_PRFTEN));
	sil_orw((void*)FLASH_ACR, (ACR_DCRST | ACR_ICRST));
	/* FLASH ROMΥץեåХåեDå塢Iåͭ */
	sil_orw((void*)FLASH_ACR, (ACR_DCEN | ACR_ICEN | ACR_PRFTEN));

	/* PLL򥷥ƥ९å */
	sil_andw((void*)RCC_CFGR, ~CFGR_SW_MASK);
	sil_orw((void*)RCC_CFGR, CFGR_SW_PLL);
  
	/* PLLΥƥ९åԤ */
	while((sil_rew_mem((void*)RCC_CFGR) & CFGR_SWS_MASK) != (CFGR_SW_PLL << 2));

	/*
	 *  åװ¸ν
	 */
	chip_initialize();

	/*
	 *  ڥեͭ
     *  USART6(RS232_1)
	 */
	sil_orw((void*)RCC_AHB1ENR, AHB1ENR_GPIOG_EN | AHB1ENR_GPIOC_EN);
	sil_orw((void*)RCC_APB2ENR, APB2ENR_USART6_EN);
#if (TNUM_PORT >= 2)
	/*
     *  USART3(RS232_1)
	 */
	sil_orw((void*)RCC_AHB1ENR, AHB1ENR_GPIOD_EN);
	sil_orw((void*)RCC_APB1ENR, APB1ENR_USART3_EN);
#endif
	/*
	 *  I/OݡȤν
     *  Alternative Function
     *  MODE: mode, output speed
     *  CNF: pull-up/pull-down, output type
	 */
	/* USART6(RX) */
	set_cr_af(GPIOG_BASE, 9, 8);
	set_cr_mode(GPIOG_BASE, 9, MODE_AF);
	set_cr_otype(GPIOG_BASE, 9, OTYPE_PP);
	set_cr_ospeed(GPIOG_BASE, 9, OSPEED_50MHz);
	set_cr_pupd(GPIOG_BASE, 9, PUPD_UP);

	/* USART6(TX) */
	set_cr_af(GPIOC_BASE, 6, 8);
	set_cr_mode(GPIOC_BASE, 6, MODE_AF);
	set_cr_otype(GPIOC_BASE, 6, OTYPE_PP);
	set_cr_ospeed(GPIOC_BASE, 6, OSPEED_50MHz);
	set_cr_pupd(GPIOC_BASE, 6, PUPD_UP);

#if (TNUM_PORT >= 2)
	/* USART3(RX) */
	set_cr_af(GPIOD_BASE, 9, 7);
	set_cr_mode(GPIOD_BASE, 9, MODE_AF);
	set_cr_otype(GPIOD_BASE, 9, OTYPE_PP);
	set_cr_ospeed(GPIOD_BASE, 9, OSPEED_50MHz);
	set_cr_pupd(GPIOD_BASE, 9, PUPD_UP);

	/* USART3(TX) */
	set_cr_af(GPIOD_BASE, 8, 7);
	set_cr_mode(GPIOD_BASE, 8, MODE_AF);
	set_cr_otype(GPIOD_BASE, 8, OTYPE_PP);
	set_cr_ospeed(GPIOD_BASE, 8, OSPEED_50MHz);
	set_cr_pupd(GPIOD_BASE, 8, PUPD_UP);
#endif

    /*
     *  MPUν
     */
    target_mpu_initialize();

	/*
	 *  ХʡѤΥꥢ
	 */
	usart_init(SIO_PORTID);
}

/*
 * åȰ¸λ
 */
void
target_exit(void)
{
	/* åװ¸νλ */
	chip_exit();
	while(1);
}

 /*
 * ƥ٥ϤΤʸ
 */
void
target_fput_log(char c)
{
	if (c == '\n') {
		sio_pol_snd_chr('\r', SIO_PORTID);
	}
	sio_pol_snd_chr(c, SIO_PORTID);
}

